<template>
  <section class="searchResults" v-on:keyup="closeSearch">
    <section class="searchResults__innerContainer">
      <spinner v-if="isLoading"></spinner>
      <section class="searchResults__items" v-if="items.length">
        <div class="searchResults__item" v-for="item in items" v-if="!isLoading" @click="onSelectItem(item)">
          <div class="searchResults__item__image" v-bind:style="{ backgroundImage: 'url(' + item.album.cover + ')' }"></div>
          <div class="searchResults__item__title">{{item.title}}</div>
          <div class="searchResults__item__artist">{{item.artist.name}}</div>
        </div>
      </section>
      <section class="noResult" v-if="!items.length && !isLoading">Nothing found</section>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';

@Component({
  props: {
    isLoading: Boolean,
    items: Array,
  },
})
export default class SearchResults extends Vue {
  closeSearch() {
    this.$store.dispatch('closeSearch');
  }

  onSelectItem(track) {
    this.$store.dispatch('play', track);
    this.$store.dispatch('fetchArtistTracks', track.artist.id);
    this.$store.dispatch('setCurrentPlaylistName', track.artist.name);
    this.closeSearch();
  }

  onOutsideClick(event) {
    if (this.isLoading) {
      return;
    }
    if (event.keyCode === 27 || (!this.$el.contains(event.target) && !event.target.classList.contains('search__input'))) {
      document.removeEventListener('click', this.onOutsideClick);
      document.removeEventListener('keyup', this.onOutsideClick);
      this.$store.dispatch('closeSearch');
    }
  }

  mounted() {
    setTimeout(() => {
      document.addEventListener('click', this.onOutsideClick);
      document.addEventListener('keyup', this.onOutsideClick);
    }, 10);
  }
}
</script>

<style lang="stylus">
.searchResults
  position absolute
  top 60px
  left 0
  right 0
  width 100%
  height 200px
  background #1c212c
  display flex
  flex-direction column
  overflow hidden
  box-shadow rgba(41,41,41,.2) 0px 1px 3px 0px, rgba(0,0,0,.14) 0px 1px 1px 0px, rgba(0,0,0,.12) 0px 2px 1px -1px

  .spinner
    position absolute
    left 50%
    margin-left -12px
    top 10px

  &__innerContainer
    display flex
    justify-content center
    padding-top 12px
    height 100%
    position relative
  
  &__items
    display flex
    width 100%
    justify-content center

  &__item
    display block
    margin 0 8px
    width 120px
    max-width 120px
    min-width 120px
    overflow hidden
    cursor pointer
    text-align center
    opacity 1

    &__image
      transition all .12s linear
      height 110px
      background-size cover
      background-position center
      background-repeat no-repeat
      background-color rgba(255,255,255,.03)
      border-radius 4px

    &__title
      padding-top 12px
      font-size 13px
      font-weight 600
      text-align center
      max-width 100%
      overflow hidden
      white-space nowrap
      text-overflow ellipsis

    &__artist
      font-size 11px
      font-weight 600
      text-align center
      color #8f94a0
      max-width 100%
      overflow hidden
      white-space nowrap
      text-overflow ellipsis

    &:hover
      .searchResults__item__image
        opacity .8
</style>